use lib "t/testlib";
use TestAuto;

use strict;
use warnings;

use Test::More;

use SPVM 'TestCase::Literal::StringSingleQuote';

my $api = SPVM::api();

# Start objects count
my $start_memory_blocks_count = $api->get_memory_blocks_count();

# StringSingleQuote literal
{
  ok(SPVM::TestCase::Literal::StringSingleQuote->characters);
  ok(SPVM::TestCase::Literal::StringSingleQuote->escape_character);
}

# All object is freed
$api->set_exception(undef);
my $end_memory_blocks_count = $api->get_memory_blocks_count();
is($end_memory_blocks_count, $start_memory_blocks_count);

done_testing;
